Loading...
Searching...
No Matches
gtsam::GenericValue< T > Class Template Reference

## Detailed Description

template<class T>
class gtsam::GenericValue< T >

Wraps any type T so it can play as a Value.

Inheritance diagram for gtsam::GenericValue< T >:

## Public Member Functions

| GenericValue (const T &value)
| Construct from value.
const T & | value () const
| Return a constant value.
T & | value ()
| Return the value.
| ~GenericValue () override
| Destructor.
bool | equals_ (const Value &p, double tol=1e-9) const override
| equals implementing generic Value interface
bool | equals (const GenericValue &other, double tol=1e-9) const
| non virtual equals function, uses traits
void | print (const std::string &str) const override
| Virtual print function, uses traits.
Value * | clone_ () const override
| Create a duplicate object returned as a pointer to the generic Value interface.
void | deallocate_ () const override
| Destroy and deallocate this object, only if it was originally allocated using clone_().
boost::shared_ptr< Value > | clone () const override
| Clone this value (normal clone on the heap, delete with 'delete' operator).
Value * | retract_ (const Vector &delta) const override
| Generic Value interface version of retract.
Vector | localCoordinates_ (const Value &value2) const override
| Generic Value interface version of localCoordinates.
GenericValue | retract (const Vector &delta) const
| Non-virtual version of retract.
Vector | localCoordinates (const GenericValue &value2) const
| Non-virtual version of localCoordinates.
size_t | dim () const override
| Return run-time dimensionality.
Value & | operator= (const Value &rhs) override
| Assignment operator.
Public Member Functions inherited from gtsam::Value
template<typename ValueType>
const ValueType & | cast () const
| Cast to known ValueType.
virtual | ~Value ()
| Virutal destructor.

## Public Types

typedef T | type

## Protected Member Functions

GenericValue< T > & | operator= (const GenericValue< T > &rhs)
| Assignment operator, protected because only the Value or DERIVED assignment operators should be used.

## Protected Attributes

T | value_
| The wrapped value.

## Friends

class | boost::serialization::access
| Serialization function.

## Member Function Documentation

## clone()

template<class T>

boost::shared_ptr< Value > gtsam::GenericValue< T >::clone | ( |  | ) | const

inline override virtual

Clone this value (normal clone on the heap, delete with 'delete' operator).

Implements gtsam::Value.

## clone_()

template<class T>

Value * gtsam::GenericValue< T >::clone_ | ( |  | ) | const

inline override virtual

Create a duplicate object returned as a pointer to the generic Value interface.

Implements gtsam::Value.

## deallocate_()

template<class T>

void gtsam::GenericValue< T >::deallocate_ | ( |  | ) | const

inline override virtual

Destroy and deallocate this object, only if it was originally allocated using clone_().

Implements gtsam::Value.

## dim()

template<class T>

size_t gtsam::GenericValue< T >::dim | ( |  | ) | const

inline override virtual

Return run-time dimensionality.

Implements gtsam::Value.

## equals_()

template<class T>

bool gtsam::GenericValue< T >::equals_ | ( | const Value & | p,
|  | double | tol = 1e-9 ) const

inline override virtual

equals implementing generic Value interface

Implements gtsam::Value.

## localCoordinates_()

template<class T>

Vector gtsam::GenericValue< T >::localCoordinates_ | ( | const Value & | value2 | ) | const

inline override virtual

Generic Value interface version of localCoordinates.

Implements gtsam::Value.

## operator=()

template<class T>

Value & gtsam::GenericValue< T >::operator= | ( | const Value & | rhs | ) |

inline override virtual

Assignment operator.

Reimplemented from gtsam::Value.

## print()

template<class T>

void gtsam::GenericValue< T >::print | ( | const std::string & | str | ) | const

inline override virtual

Virtual print function, uses traits.

Implements gtsam::Value.

## retract_()

template<class T>

Value * gtsam::GenericValue< T >::retract_ | ( | const Vector & | delta | ) | const

inline override virtual

Generic Value interface version of retract.

Implements gtsam::Value.

The documentation for this class was generated from the following file:

- /build/gtsam-Xg031d/gtsam-4.2.0+dfsg/gtsam/base/GenericValue.h